#ifndef NODE_H
#define NODE_H

typedef unsigned long long uint64;

struct node {
       struct node *l, *r;
       int    type;
       uint64 count; // how many packets
       uint64 size;  // total size from all packets
     };

struct node *get_node (struct node *n, int type);
struct node *new_node (struct node *n, int type);
uint64 count_sump (struct node *n);
uint64 count_sums (struct node *n);

// get an array of pointers to the largest n nodes
void largestn (struct node *r, struct node **a, int n, u_char sort_type);

// delete the tree of nodes
void ndelete (struct node *r);


#endif
